<template>
    <v-flex xs12>
        <v-card class="elevation-12">
            <v-toolbar dark color="primary">
                <v-toolbar-title>Login</v-toolbar-title>
                <v-spacer></v-spacer>
                <v-tooltip bottom>
                    <v-btn
                            icon
                            large
                            target="_blank"
                            slot="activator"
                    >
                        <v-icon large>fa-sign-in-alt</v-icon>
                    </v-btn>
                    <span>Login</span>
                </v-tooltip>
            </v-toolbar>
            <v-card-text>
                <v-form @submit.prevent="handleSubmit">
                    <v-text-field prepend-icon="person"
                                  required
                                  email
                                  :error-messages="emailErrors"
                                  v-model.trim="email"
                                  @input="$v.email.$touch()"
                                  :class="{ 'is-invalid': $v.email.$error }"
                                  name="email"
                                  label="email"
                                  id="email"
                                  type="email"></v-text-field>
                    <v-text-field @input="$v.password.$touch()"
                                  :class="{ 'is-invalid': $v.password.$error }"
                                  required
                                  :error-messages="passwordErrors"
                                  v-model.trim="password"
                                  prepend-icon="lock"
                                  name="password"
                                  label="Password"
                                  id="password"
                                  type="password"></v-text-field>

                    <v-card-actions>
                        <v-layout justify-center align-center>
                            <v-btn
                                    :loading="loading"
                                    :disabled="loading || $v.$invalid"
                                    align="center"
                                    color="primary"
                                    type="submit">
                                Login
                                <span slot="loader" class="custom-loader">
        <v-icon light>cached</v-icon>
      </span>
                            </v-btn>
                        </v-layout>
                    </v-card-actions>
                </v-form>
                <b-alert variant="success" show>
                    <strong>Don't have an account ?</strong>
                    <router-link :to="{name: 'register'}">
                        <v-btn color="success" class="m-1" type="btn">Register here</v-btn>
                    </router-link>
                </b-alert>
            </v-card-text>
        </v-card>
    </v-flex>
</template>

<script>
    import {validationMixin} from 'vuelidate'
    import {required, email} from "vuelidate/lib/validators";
    import {mapActions} from 'vuex';
    import Card from '../Card'

    const validations = {
        email: {required, email},
        password: {required}
    };

    const devEnv = process.env.NODE_ENV === 'development';//TODO: code this a better way :(

    export default {
        mixins: [validationMixin],
        name: "LoginForm",
        components: {
            Card
        },
        data() {
            return {
                loader:null,
                loading: false,
                cardTitle: 'Login',
                cardIcon: 'face',
                email: "",
                password: "",
                showFormInfoAlert: false,
                submitting: false,
                env: devEnv //TODO: code this a better way :(
            };
        },
        validations,
        methods: {
            ...mapActions(["login"]),
            handleSubmit(e) {
                this.$v.$touch();
                if (!this.$v.$invalid) {
                    this.loader='loading';
                    const user = {
                        email: this.email,
                        password: this.password
                    };
                    this.login({router: this.$router, user: user});
                }
            },
        },
        watch:{
            loader () {
                const l = this.loader
                this[l] = !this[l]

                setTimeout(() => (this[l] = false), 500)

                this.loader = null
            }
        },
        computed: {
            emailErrors() {
                const errors = []
                if (!this.$v.email.$dirty) return errors
                !this.$v.email.email && errors.push('Must be valid e-mail')
                !this.$v.email.required && errors.push('E-mail is required')
                return errors
            },
            passwordErrors() {
                const errors = []
                if (!this.$v.password.$dirty) return errors
                !this.$v.password.required && errors.push('Password is required')
                return errors
            }
        },
        mounted() {
        }
    };
</script>
<style>
    .custom-loader {
        animation: loader 1s infinite;
        display: flex;
    }

    @-moz-keyframes loader {
        from {
            transform: rotate(0);
        }
        to {
            transform: rotate(360deg);
        }
    }

    @-webkit-keyframes loader {
        from {
            transform: rotate(0);
        }
        to {
            transform: rotate(360deg);
        }
    }

    @-o-keyframes loader {
        from {
            transform: rotate(0);
        }
        to {
            transform: rotate(360deg);
        }
    }

    @keyframes loader {
        from {
            transform: rotate(0);
        }
        to {
            transform: rotate(360deg);
        }
    }
</style>
